{ Copyright (C) 2025  StOver }
Unit
          alignComponentsImpl;

          {$mode objfpc}{$H+}

Interface


Procedure
          Register;

implementation

Uses
          Classes,
          SysUtils,
          Controls,
          Forms,
          Dialogs,
          menuintf,
          IDECommands,
          ToolBarIntf,
          FormEditingIntf,
          propedits,
          lcltype;

          {$R alignComponents_images.res}

Const
          // first selected component rules
          SALIGN_LFT                        = 'align_left';
          SALIGN_RGT                        = 'align_right';
          SALIGN_TOP                        = 'align_top';
          SALIGN_BTM                        = 'align_bottom';

          // lowest/highest value rules
          SALIGN_LFT_MST                    = 'align_leftmost';
          SALIGN_RGT_MST                    = 'align_rightmost';
          SALIGN_TOP_MST                    = 'align_topmost';
          SALIGN_BTM_MST                    = 'align_bottommost';


Resourcestring

          SALIGN_LFT_IDEMenuCaption         = 'Nach links ausrichten';
          SALIGN_RGT_IDEMenuCaption         = 'Nach rechts ausrichten';
          SALIGN_TOP_IDEMenuCaption         = 'Nach oben ausrichten';
          SALIGN_BTM_IDEMenuCaption         = 'Nach unten ausrichten';

          SALIGN_LFT_MST_IDEMenuCaption     = 'Nach linkster ausrichten';
          SALIGN_RGT_MST_IDEMenuCaption     = 'Nach rechtester ausrichten';
          SALIGN_TOP_MST_IDEMenuCaption     = 'Nach oberster ausrichten';
          SALIGN_BTM_MST_IDEMenuCaption     = 'Nach unterster ausrichten';


Type

          { tHelpObj }

          tHelpObj                          = Class( tObject)

             pslCurSelComps                 : tPersistentSelectionList;
             pslCurSelCtrls                 : tPersistentSelectionList;

             Function                       getNonFormSelection( Const aSelection: tPersistentSelectionList): tPersistentSelectionList;
             Function                       getControlSelection(): tPersistentSelectionList;
             Procedure                      PropHookSetSelection( Const aSelection: tPersistentSelectionList);

             Procedure                      xAbleOne( aCmd: tIDEMenuCommand; aEnable: Boolean);
             Procedure                      xAbleCommands( aCompSel: intEger; aCtrlSel: intEger);
             Function                       refreshPSLists( Const aSelection: tPersistentSelectionList): boolEAN;
             Procedure                      refreshCmdsXablation( Const aSelection: tPersistentSelectionList);

             Procedure                      tryRefreshLUR();

             Procedure                      alignTopOrLeft( aIsLeft: Boolean; aTemplIdx: intEger= 0);
             Procedure                      alignLeft( aSender: tObject);
             Procedure                      alignTop( aSender: tObject);

             Function                       getLeftOrTopMostIdx( aIsLeft: boolEan): intEger;

             Function                       checkSelectionAndIndex( aInTemplIdx: intEger; Out aOutTemplIdx: intEger): boolEan;

             Procedure                      alignLeftMost( aSender: tObject);
             Procedure                      alignTopMost( aSender: tObject);

             Procedure                      alignRightOrBottom( aIsRight: Boolean; aTemplIdx: intEger= 0);
             Procedure                      alignRight( aSender: tObject);
             Procedure                      alignBottom( aSender: tObject);

             Function                       getRightOrBottomMostIdx( aIsRight: boolEan): intEger;

             Procedure                      alignRightMost( aSender: tObject);
             Procedure                      alignBottomMost( aSender: tObject);

          Public

             Constructor                    create();
          End;


Var
          imcCmd_LFT                        : tIDEMenuCommand= Nil;
          imcCmd_RGT                        : tIDEMenuCommand= Nil;
          imcCmd_TOP                        : tIDEMenuCommand= Nil;
          imcCmd_BTM                        : tIDEMenuCommand= Nil;

          imcCmd_LFT_MST                    : tIDEMenuCommand= Nil;
          imcCmd_RGT_MST                    : tIDEMenuCommand= Nil;
          imcCmd_TOP_MST                    : tIDEMenuCommand= Nil;
          imcCmd_BTM_MST                    : tIDEMenuCommand= Nil;

          {$hints off}
          ho_Obj: tHelpObj                  = Nil;

Procedure
          nOp( aSender: tObject);
Begin

End;
          {$hints on}
Procedure
          Register;
Var
          Key                               : tIDEShortCut;
          Cat                               : tIdeCommandCategory;
          Cmd                               : tIdeCommand;
Begin
          If not assigned( GlobalDesignHook)
             Then
             Exit;

          Key:= IDEShortCut( vk_unknown, []);
          Cat:= IDECommandList.FindCategoryByName( CommandCategoryToolMenuName);

          // first comp in list defines
          // left
          Cmd:= RegisterIDECommand( Cat, SALIGN_LFT, SALIGN_LFT_IDEMenuCaption, Key, @ho_Obj.alignLeft  , Nil);
          RegisterIDEButtonCommand( Cmd);
          imcCmd_LFT:= RegisterIDEMenuCommand( itmSecondaryTools, SALIGN_LFT, SALIGN_LFT_IDEMenuCaption, @ho_Obj.alignLeft  , Nil, Cmd, AnsiLowerCase( SALIGN_LFT));

          // top
          Cmd:= RegisterIDECommand( Cat, SALIGN_TOP, SALIGN_TOP_IDEMenuCaption, Key, @ho_Obj.alignTop   , Nil);
          RegisterIDEButtonCommand( Cmd);
          imcCmd_TOP:= RegisterIDEMenuCommand( itmSecondaryTools, SALIGN_TOP, SALIGN_TOP_IDEMenuCaption, @ho_Obj.alignTop   , Nil, Cmd, AnsiLowerCase( SALIGN_TOP));

          // right
          Cmd:= RegisterIDECommand( Cat, SALIGN_RGT, SALIGN_RGT_IDEMenuCaption, Key, @ho_Obj.alignRight , Nil);
          RegisterIDEButtonCommand( Cmd);
          imcCmd_RGT:= RegisterIDEMenuCommand( itmSecondaryTools, SALIGN_RGT, SALIGN_RGT_IDEMenuCaption, @ho_Obj.alignRight , Nil, Cmd, AnsiLowerCase( SALIGN_RGT));

          // bottom
          Cmd:= RegisterIDECommand( Cat, SALIGN_BTM, SALIGN_BTM_IDEMenuCaption, Key, @ho_Obj.alignBottom, Nil);
          RegisterIDEButtonCommand( Cmd);
          imcCmd_BTM:= RegisterIDEMenuCommand( itmSecondaryTools, SALIGN_BTM, SALIGN_BTM_IDEMenuCaption, @ho_Obj.alignBottom, Nil, Cmd, AnsiLowerCase( SALIGN_BTM));

          // "most" value of selected
          // left most
          Cmd:= RegisterIDECommand( Cat, SALIGN_LFT_MST, SALIGN_LFT_MST_IDEMenuCaption, Key, @ho_Obj.alignLeftMost, Nil);
          RegisterIDEButtonCommand( Cmd);
          imcCmd_LFT_MST:= RegisterIDEMenuCommand( itmSecondaryTools, SALIGN_LFT_MST, SALIGN_LFT_MST_IDEMenuCaption, @ho_Obj.alignLeftMost, Nil, Cmd, AnsiLowerCase( SALIGN_LFT_MST));

          // top most
          Cmd:= RegisterIDECommand( Cat, SALIGN_TOP_MST, SALIGN_TOP_MST_IDEMenuCaption, Key, @ho_Obj.alignTopMost, Nil);
          RegisterIDEButtonCommand( Cmd);
          imcCmd_TOP_MST:= RegisterIDEMenuCommand( itmSecondaryTools, SALIGN_TOP_MST, SALIGN_TOP_MST_IDEMenuCaption, @ho_Obj.alignTopMost, Nil, Cmd, AnsiLowerCase( SALIGN_TOP_MST));

          // right most
          Cmd:= RegisterIDECommand( Cat, SALIGN_RGT_MST, SALIGN_RGT_MST_IDEMenuCaption, Key, @ho_Obj.alignRightMost, Nil);
          RegisterIDEButtonCommand( Cmd);
          imcCmd_RGT_MST:= RegisterIDEMenuCommand( itmSecondaryTools, SALIGN_RGT_MST, SALIGN_RGT_MST_IDEMenuCaption, @ho_Obj.alignRightMost, Nil, Cmd, AnsiLowerCase( SALIGN_RGT_MST));

          // bttom most
          Cmd:= RegisterIDECommand( Cat, SALIGN_BTM_MST, SALIGN_BTM_MST_IDEMenuCaption, Key, @ho_Obj.alignBottomMost, Nil);
          RegisterIDEButtonCommand( Cmd);
          imcCmd_BTM_MST:= RegisterIDEMenuCommand( itmSecondaryTools, SALIGN_BTM_MST, SALIGN_BTM_MST_IDEMenuCaption, @ho_Obj.alignBottomMost, Nil, Cmd, AnsiLowerCase( SALIGN_BTM_MST));


          GlobalDesignHook.AddHandlerSetSelection( @ho_Obj.PropHookSetSelection);

End;

{ tHelpObj }

Function
          tHelpObj.getNonFormSelection( Const aSelection: tPersistentSelectionList): tPersistentSelectionList;
Var
          vIn1                              : intEger;
          vIn2                              : intEger;
Begin
          Result:= tPersistentSelectionList.Create();

          If assigned( aSelection)
             Then
             Begin
                  vIn2:= aSelection.Count;
                  For vIn1:= 0 To vIn2- 1
                      Do
                      Begin
                           If ( aSelection[ vIn1] is tComponent)
                              And
                              Not ( aSelection[ vIn1] is tCustomForm)
                              Then
                              Result.Add( aSelection[ vIn1]);
                  End;

          End;
End;

Function
          tHelpObj.getControlSelection(): tPersistentSelectionList;
Var
          vIn1                              : intEger;
          vIn2                              : intEger;
Begin
          Result:= tPersistentSelectionList.Create();

          If assigned( pslCurSelComps)
             Then
             Begin
                  vIn2:= pslCurSelComps.Count;
                  For vIn1:= 0 To vIn2- 1
                      Do
                      Begin
                           If ( pslCurSelComps[ vIn1] is tControl)
                              And
                              Not ( pslCurSelComps[ vIn1] is tCustomForm)
                              Then
                              Result.Add( pslCurSelComps[ vIn1]);
                  End;
          End;
End;

Procedure
          tHelpObj.xAbleOne( aCmd: tIDEMenuCommand; aEnable: Boolean);
Begin
          If assigned( aCmd)
             Then
             aCmd.Enabled:= aEnable;
End;

Procedure
          tHelpObj.xAbleCommands( aCompSel: intEger; aCtrlSel: intEger);
Begin
          xAbleOne( imcCmd_LFT, False);
          xAbleOne( imcCmd_RGT, False);
          xAbleOne( imcCmd_TOP, False);
          xAbleOne( imcCmd_BTM, False);

          xAbleOne( imcCmd_LFT_MST, False);
          xAbleOne( imcCmd_RGT_MST, False);
          xAbleOne( imcCmd_TOP_MST, False);
          xAbleOne( imcCmd_BTM_MST, False);

          If ( aCompSel> 1)
             Then
             Begin
                  xAbleOne( imcCmd_LFT, True);
                  xAbleOne( imcCmd_TOP, True);

                  xAbleOne( imcCmd_LFT_MST, True);
                  xAbleOne( imcCmd_TOP_MST, True);

                  If ( aCompSel= aCtrlSel)
                     Then
                     Begin
                          xAbleOne( imcCmd_RGT, True);
                          xAbleOne( imcCmd_BTM, True);

                          xAbleOne( imcCmd_RGT_MST, True);
                          xAbleOne( imcCmd_BTM_MST, True);
                  End;
          End;
End;

Function
          tHelpObj.refreshPSLists( Const aSelection: tPersistentSelectionList): boolEAN;
Begin
          Result:= False;

          pslCurSelComps:= getNonFormSelection( aSelection);
          pslCurSelCtrls:= Nil;

          If assigned( pslCurSelComps)
             Then
             Begin
                  pslCurSelCtrls:= getControlSelection();
                  Result:= assigned( pslCurSelCtrls);
          End;
End;

Procedure
          tHelpObj.refreshCmdsXablation( Const aSelection: tPersistentSelectionList);
Var
          vInCmps                           : intEger;
          vInCtrs                           : intEger;
Begin
          xAbleCommands( 0, 0);

          If refreshPSLists( aSelection)
             Then
             Begin
                  vInCmps:= pslCurSelComps.Count;
                  vInCtrs:= pslCurSelCtrls.Count;

                  xAbleCommands( vInCmps, vInCtrs)
          End;
End;


Procedure
          tHelpObj.PropHookSetSelection( Const aSelection: tPersistentSelectionList);
Begin
          refreshCmdsXablation( aSelection);
End;

Procedure
          tHelpObj.tryRefreshLUR();
Begin
          If not assigned( GlobalDesignHook)
             Then
             Exit;

          Try
             If assigned( GlobalDesignHook.LookupRoot)
                And
                ( GlobalDesignHook.LookupRoot Is tControl)
                Then
                tControl( GlobalDesignHook.LookupRoot).rePaint()
          Except End;
End;

Function
          tHelpObj.getLeftOrTopMostIdx( aIsLeft: boolEan): intEger;
Var
          vInMost                           : intEger;
          vInLftC                           : intEger;
          vInTopC                           : intEger;
          vIn1                              : intEger;
          vIn2                              : intEger;
Begin
          Result:= -1;

          If Not assigned( pslCurSelComps)
             Then
             Exit;

          If ( pslCurSelComps.Count< 2)
             Then
             Exit;

          Try
             vInMost:= MaxInt;
             vIn2:= pslCurSelComps.Count;

             For vIn1:= 0 To vIn2- 1
                 Do
                 Begin
                      GetComponentLeftTopOrDesignInfo( tComponent( pslCurSelComps[ vIn1]), vInLftC, vInTopC);

                      If     aIsLeft And ( vInLftC< vInMost)
                         Then
                         Begin
                              vInMost:= vInLftC;
                              Result:= vIn1;
                      End;

                      If Not aIsLeft And ( vInTopC< vInMost)
                         Then
                         Begin
                              vInMost:= vInTopC;
                              Result:= vIn1;
                      End;

             End;
          Except End;
End;

Procedure
          tHelpObj.alignTopOrLeft( aIsLeft: Boolean; aTemplIdx: intEger= 0);
Var
          vInTIx                            : intEger;
          vInLft                            : intEger;
          vInTop                            : intEger;
          vInLftC                           : intEger;
          vInTopC                           : intEger;
          vIn1                              : intEger;
          vIn2                              : intEger;
Begin
          If Not assigned( pslCurSelComps)
             Then
             Exit;

          If ( pslCurSelComps.Count< 2)
             Then
             Exit;

          vInTIx:= aTemplIdx;
          If ( 0> vInTIx)
             Or
             ( pslCurSelComps.Count<= vInTIx)
             Then
             vInTIx:= 0;

          Try
             GetComponentLeftTopOrDesignInfo( tComponent( pslCurSelComps[ vInTIx]), vInLft, vInTop);

             vIn2:= pslCurSelComps.Count;

             For vIn1:= 0 To vIn2- 1
                 Do
                 Begin
                      If ( vInTIx<> vIn1)
                         Then
                         Begin
                              GetComponentLeftTopOrDesignInfo( tComponent( pslCurSelComps[ vIn1]), vInLftC, vInTopC);

                              If aIsLeft
                                 Then
                                 SetComponentLeftTopOrDesignInfo( tComponent( pslCurSelComps[ vIn1]), vInLft, vInTopC)
                              Else
                                 SetComponentLeftTopOrDesignInfo( tComponent( pslCurSelComps[ vIn1]), vInLftC, vInTop)
                      End;
             End;
             tryRefreshLUR();

          Except End;
End;


Procedure
          tHelpObj.alignLeft( aSender: tObject);
Begin
          nOp( aSender);
          alignTopOrLeft( True);
End;

Procedure
          tHelpObj.alignTop( aSender: tObject);
Begin
          nOp( aSender);
          alignTopOrLeft( False);
End;

Procedure
          tHelpObj.alignLeftMost( aSender: tObject);
Var
          vInTmplIdx                        : intEger;
Begin
          nOp( aSender);
          vInTmplIdx:= getLeftOrTopMostIdx( True);

          If ( -1< vInTmplIdx)
             Then
             alignTopOrLeft( True, vInTmplIdx);
End;

Procedure
          tHelpObj.alignTopMost( aSender: tObject);
Var
          vInTmplIdx                        : intEger;
Begin
          nOp( aSender);

          vInTmplIdx:= getLeftOrTopMostIdx( False);
          If ( -1< vInTmplIdx)
             Then
             alignTopOrLeft( False, vInTmplIdx);
End;

Function
          tHelpObj.checkSelectionAndIndex( aInTemplIdx: intEger; Out aOutTemplIdx: intEger): boolEan;
Begin
          Result      := False;
          aOutTemplIdx:= 0;

          If Not assigned( pslCurSelCtrls)
             Then
             Exit;

          If ( pslCurSelCtrls.Count< 2)
             Then
             Exit;

          If ( -1< aInTemplIdx)
             And
             ( pslCurSelCtrls.Count> aInTemplIdx)
             Then
             aOutTemplIdx:= aInTemplIdx;

          Result:= True;
End;

Procedure
          tHelpObj.alignRightOrBottom( aIsRight: Boolean; aTemplIdx: intEger= 0);
Var
          vInTIx                            : intEger;

          vInDiff                           : intEger;
          vIn1                              : intEger;
          vIn2                              : intEger;

          vtReCt                            : tRect;
          vtReCi                            : tRect;
Begin
          If Not checkSelectionAndIndex( aTemplIdx, vInTIx)
             Then
             Exit;

          Try
             vtReCt:= tControl( pslCurSelCtrls[ vInTIx]).BoundsRect;

             vIn2:= pslCurSelCtrls.Count;
             For vIn1:= 0 To vIn2- 1
                 Do
                 Begin
                      If ( vInTIx<> vIn1)
                         Then
                         Begin
                              vtReCi:= tControl( pslCurSelCtrls[ vIn1]).BoundsRect;

                              If aIsRight
                                 Then
                                 vInDiff:= vtReCt.Right - vtReCi.Right    // might be negative
                              Else
                                 vInDiff:= vtReCt.Bottom- vtReCi.Bottom;  // might be negative

                              If ( 0<> vInDiff)
                                 Then
                                 Begin
                                      If aIsRight
                                         Then
                                         Begin
                                              vtReCi.Right:= vtReCt.Right;
                                              vtReCi.Left := vtReCi.Left+ vInDiff;
                                         End
                                      Else
                                         Begin
                                              vtReCi.Bottom:= vtReCt.Bottom;
                                              vtReCi.Top   := vtReCi.Top+ vInDiff;
                                      End;
                                      tControl( pslCurSelCtrls[ vIn1]).SetBounds( vtReCi.Left, vtReCi.Top, vtReCi.Width, vtReCi.Height);
                              End;
                      End;
             End;
             tryRefreshLUR();

          Except End;
End;

Function
          tHelpObj.getRightOrBottomMostIdx( aIsRight: boolEan): intEger;
Var
          vInMost                           : intEger;
          vIn1                              : intEger;
          vIn2                              : intEger;
          vtReCi                            : tRect;

Begin
          Result:= -1;

          If Not assigned( pslCurSelCtrls)
             Then
             Exit;

          If ( pslCurSelCtrls.Count< 2)
             Then
             Exit;

          Try
             vInMost:= Low( intEger);
             vIn2:= pslCurSelCtrls.Count;

             For vIn1:= 0 To vIn2- 1
                 Do
                 Begin
                      vtReCi:= tControl( pslCurSelCtrls[ vIn1]).BoundsRect;

                      If     aIsRight And ( vtReCi.Right > vInMost)
                         Then
                         Begin
                              vInMost:= vtReCi.Right;
                              Result:= vIn1;
                      End;

                      If Not aIsRight And ( vtReCi.Bottom> vInMost)
                         Then
                         Begin
                              vInMost:= vtReCi.Bottom;
                              Result:= vIn1;
                      End;

             End;
          Except End;

End;

Procedure
          tHelpObj.alignRight( aSender: tObject);
Begin
          nOp( aSender);

          alignRightOrBottom( True);
End;

Procedure
          tHelpObj.alignBottom( aSender: tObject);
Begin
          nOp( aSender);

          alignRightOrBottom( False);
End;

Procedure
          tHelpObj.alignRightMost( aSender: tObject);
Var
          vInTmplIdx                        : intEger;
Begin
          nOp( aSender);

          vInTmplIdx:= getRightOrBottomMostIdx( True);

          If ( -1< vInTmplIdx)
             Then
             alignRightOrBottom( True, vInTmplIdx);
End;

Procedure
          tHelpObj.alignBottomMost( aSender: tObject);
Var
          vInTmplIdx                        : intEger;
Begin
          nOp( aSender);

          vInTmplIdx:= getRightOrBottomMostIdx( False);

          If ( -1< vInTmplIdx)
             Then
             alignRightOrBottom( False, vInTmplIdx);
End;

Constructor
          tHelpObj.create();
Begin
          pslCurSelComps:= Nil;
          pslCurSelCtrls:= Nil;
End;



Initialization
Begin
          ho_Obj:= tHelpObj.Create();


End;

Finalization
Begin
          If assigned( GlobalDesignHook)
             Then
             GlobalDesignHook.RemoveHandlerSetSelection( @ho_Obj.PropHookSetSelection);

End;

End.

